Index: palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_bc.f90	(revision 4501)
+++ palm/trunk/SOURCE/advec_s_bc.f90	(revision 4502)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4488 2020-04-03 11:34:29Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -957,9 +960,9 @@
           ENDDO
 
-       ELSEIF ( sk_char == 'qr' )  THEN
-
-!
-!--       Rain water content boundary condition at the bottom boundary: Dirichlet (fixed surface
-!--       rain water content).
+       ELSEIF ( sk_char == 'qi' )  THEN
+
+!
+!--       Ice crystal content boundary condition at the bottom boundary:
+!--       Dirichlet (fixed surface rain water content).
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -971,5 +974,5 @@
 
 !
-!--       Rain water content boundary condition at the top boundary: Dirichlet
+!--       Ice crystal content boundary condition at the top boundary: Dirichlet
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -979,9 +982,9 @@
           ENDDO
 
-       ELSEIF ( sk_char == 'nc' )  THEN
-
-!
-!--       Cloud drop concentration boundary condition at the bottom boundary: Dirichlet (fixed
-!--       surface cloud drop concentration).
+       ELSEIF ( sk_char == 'qr' )  THEN
+
+!
+!--       Rain water content boundary condition at the bottom boundary: Dirichlet (fixed surface
+!--       rain water content).
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -993,5 +996,49 @@
 
 !
+!--       Rain water content boundary condition at the top boundary: Dirichlet
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+                sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+             ENDDO
+          ENDDO
+
+       ELSEIF ( sk_char == 'nc' )  THEN
+
+!
+!--       Cloud drop concentration boundary condition at the bottom boundary: Dirichlet (fixed
+!--       surface cloud drop concentration).
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+                sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+                sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+             ENDDO
+          ENDDO
+
+!
 !--       Cloud drop concentration boundary condition at the top boundary: Dirichlet
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+                sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+             ENDDO
+          ENDDO
+
+       ELSEIF ( sk_char == 'ni' )  THEN
+
+!
+!--       Ice crystal concentration boundary condition at the bottom boundary:
+!--       Dirichlet (fixed surface cloud drop concentration).
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+                sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+                sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+             ENDDO
+          ENDDO
+
+!
+!--       Ice crystal concentration boundary condition at the top boundary: Dirichlet
           DO  i = nxl, nxr
              DO  j = nys, nyn
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4501)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4469 2020-03-23 14:31:00Z suehring
 ! fix mistakenly committed version
 !
@@ -240,4 +243,5 @@
                sums_wssas_ws_l, sums_wsus_ws_l, sums_wsvs_ws_l,                &
                sums_wsqcs_ws_l, sums_wsqrs_ws_l,                               &
+               sums_wsqis_ws_l, sums_wsnis_ws_l,                               &
                sums_wsncs_ws_l, sums_wsnrs_ws_l,                               &
                hom, weight_substep
@@ -1938,4 +1942,14 @@
              ENDDO
 
+          CASE ( 'qi' )
+
+             DO  k = nzb, nzt
+                sums_wsqis_ws_l(k,tn)  = sums_wsqis_ws_l(k,tn) +               &
+                    ( flux_t(k) / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                    + diss_t(k) / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS( w(k,j,i) - hom(k,1,3,0)            )  &
+                    ) * weight_substep(intermediate_timestep_count)
+             ENDDO
 
           CASE ( 'qr' )
@@ -1954,4 +1968,15 @@
              DO  k = nzb, nzt
                 sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn) +               &
+                    ( flux_t(k) / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                    + diss_t(k) / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS( w(k,j,i) - hom(k,1,3,0)            )  &
+                    ) * weight_substep(intermediate_timestep_count)
+             ENDDO
+
+          CASE ( 'ni' )
+
+             DO  k = nzb, nzt
+                sums_wsnis_ws_l(k,tn)  = sums_wsnis_ws_l(k,tn) +               &
                     ( flux_t(k) / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
@@ -3798,4 +3823,8 @@
            CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
               sk_num = 9
+           CASE ( 'ni' )
+              sk_num = 10
+           CASE ( 'qi' )
+              sk_num = 11
            CASE DEFAULT
               sk_num = 0
@@ -3824,4 +3853,5 @@
        !$ACC PRESENT(sums_wsqrs_ws_l, sums_wsncs_ws_l) &
        !$ACC PRESENT(sums_wsnrs_ws_l, sums_wsss_ws_l) &
+       !$ACC PRESENT(sums_wsnis_ws_l, sums_wsqis_ws_l) &
        !$ACC PRESENT(sums_salsa_ws_l)
        DO  i = nxl, nxr
@@ -4517,4 +4547,24 @@
                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )   &
                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 10 )
+                       !$ACC ATOMIC
+                       sums_wsnis_ws_l(k,tn)  = sums_wsnis_ws_l(k,tn)          &
+                          + ( flux_t(k)                                        &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t(k)                                        &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
+                    CASE ( 11 )
+                       !$ACC ATOMIC
+                       sums_wsqis_ws_l(k,tn)  = sums_wsqis_ws_l(k,tn)          &
+                          + ( flux_t(k)                                        &
+                                / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
+                                * ( w(k,j,i) - hom(k,1,3,0)                 )  &
+                            + diss_t(k)                                        &
+                                / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
+                                *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
+                            ) * weight_substep(intermediate_timestep_count)
 
                 END SELECT
Index: palm/trunk/SOURCE/basic_constants_and_equations_mod.f90
===================================================================
--- palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4400 2020-02-10 20:32:41Z suehring
 ! Move routine to transform coordinates from netcdf_interface_mod to 
 ! basic_constants_and_equations_mod
@@ -92,4 +95,5 @@
     REAL(wp), PARAMETER ::  g_d_cp  = g   / c_p   !< precomputed g / c_p
     REAL(wp), PARAMETER ::  lv_d_cp = l_v / c_p   !< precomputed l_v / c_p
+    REAL(wp), PARAMETER ::  ls_d_cp = l_s / c_p   !< precomputed l_s / c_p
     REAL(wp), PARAMETER ::  lv_d_rd = l_v / r_d   !< precomputed l_v / r_d
     REAL(wp), PARAMETER ::  rd_d_rv = r_d / r_v   !< precomputed r_d / r_v
@@ -106,4 +110,8 @@
     PRIVATE magnus_0d, &
             magnus_1d, &
+            magnus_tl_0d, &
+            magnus_tl_1d, &
+            magnus_0d_ice, &
+            magnus_1d_ice, &
             ideal_gas_law_rho_0d, &
             ideal_gas_law_rho_1d, &
@@ -126,4 +134,14 @@
        MODULE PROCEDURE magnus_1d
     END INTERFACE magnus
+
+    INTERFACE magnus_tl
+       MODULE PROCEDURE magnus_tl_0d
+       MODULE PROCEDURE magnus_tl_1d
+    END INTERFACE magnus_tl
+
+    INTERFACE magnus_ice
+       MODULE PROCEDURE magnus_0d_ice
+       MODULE PROCEDURE magnus_1d_ice
+    END INTERFACE magnus_ice
 
     INTERFACE ideal_gas_law_rho
@@ -337,4 +355,90 @@
 ! Description:
 ! ------------
+!> This function computes the magnus formula (Press et al., 1992) using the
+!> (ice-) liquid water potential temperature.
+!> The magnus formula is needed to calculate the saturation vapor pressure over
+!> a plane liquid water surface
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_tl_0d( t_l )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  t_l  !< liquid water temperature (K)
+
+       REAL(wp) ::  magnus_tl_0d
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_tl_0d =  610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /             &
+                                                    ( t_l - 35.86_wp  ) )
+
+    END FUNCTION magnus_tl_0d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This function computes the magnus formula (Press et al., 1992) using the
+!> (ice-) liquid water potential temperature.
+!> The magnus formula is needed to calculate the saturation vapor pressure over
+!> a plane liquid water surface
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_tl_1d( t_l )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  t_l  !< liquid water temperature (K)
+
+       REAL(wp), DIMENSION(size(t_l)) ::  magnus_tl_1d
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_tl_1d =  610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /      &
+                                                    ( t_l - 35.86_wp  ) )
+
+    END FUNCTION magnus_tl_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This function computes the magnus formula (Press et al., 1992).
+!> The magnus formula is needed to calculate the saturation vapor pressure over
+!> a plane ice surface
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_0d_ice( t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN) ::  t  !< temperature (K)
+
+       REAL(wp) ::  magnus_0d_ice
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_0d_ice =  611.2_wp * EXP( 22.46_wp * ( t - degc_to_k ) /         &
+                                                   ( t - 0.53_wp  ) )
+
+    END FUNCTION magnus_0d_ice
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This function computes the magnus formula (Press et al., 1992).
+!> The magnus formula is needed to calculate the saturation vapor pressure over
+!> a plane ice surface
+!------------------------------------------------------------------------------!
+    FUNCTION magnus_1d_ice( t )
+
+       IMPLICIT NONE
+
+       REAL(wp), INTENT(IN), DIMENSION(:) ::  t  !< temperature (K)
+
+       REAL(wp), DIMENSION(size(t)) ::  magnus_1d_ice
+!
+!--    Saturation vapor pressure for a specific temperature:
+       magnus_1d_ice =  611.2_wp * EXP( 22.46_wp * ( t - degc_to_k ) /          &
+                                                   ( t - 0.53_wp  ) )
+
+    END FUNCTION magnus_1d_ice
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Compute the ideal gas law for scalar arguments.
 !------------------------------------------------------------------------------!
